#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "briefomat.h"
#include "parser.h"

void not_yet_implemented()
{

}

void *do_print_thread()
{
char buffer[300];
if ( strlen( getenv("HOME") ) > 256 )
  {
    printf("Fehler: Verzeichnisname mehr als 256 Zeichen");
    exit(1);
  }
else
  {
    mk_tmp_tex();
    sprintf(buffer,"cd %s;latex %s/briefomat-tmp;dvips -f -t a4 %s/briefomat-tmp | lpr",getenv("HOME"),getenv("HOME"),getenv("HOME"));
    printf("debug:%s\n",buffer);
    system(buffer);
  }
}

void sh_write(int fd,void *buf)
{
if( (fd!=0)*(buf!=0)*(1) )
  write(fd,buf,strlen(buf));
}


char *adressparser(char *adresse)
{
char *buffer,already=0;
int i=0,j=0,k=0;
while(adresse[i]!='\0')
  {
    if (adresse[i]=='\n')
      j++;
    i++;
  }
buffer=(char *)malloc(strlen(adresse)+j);
for(j=0;j<i;j++)
  {
    if (adresse[j]!='\n')
      {
	buffer[k]=adresse[j];
	already=0;
      }
    else
      if (!already)
	{
	  buffer[k]='\\';
	  k++;
	  buffer[k]='\\';
	  already=1;
	}
      else
	{
	  buffer[k]='\n';
	  already=0;
	}
    k++;
  }
buffer[k]='\0';
return buffer;
}

void *mk_tmp_tex()
{
int fd;
char buffer[300];
if ( strlen( getenv("HOME") ) > 256 )
  {
    printf("Fehler: Verzeichnisname mehr als 256 Zeichen");
    exit(1);
  }
sprintf(buffer,"%s/briefomat-tmp.tex",getenv("HOME"));
if ( -1== (fd = open(buffer,O_RDWR| O_CREAT,S_IRUSR+S_IWUSR)) ) 
  printf("Fehler beim ffnen von %s",buffer);
else
  {
    sh_write(fd,"%btex File generated with briefomat\n");
    sh_write(fd,"\\documentclass[12pt,german]{g-brief}\n"); 
    sh_write(fd,"\\usepackage[latin1]{inputenc}\n");
    if (briefkopf) 
      {
	sh_write(fd,"\\usepackage{graphicx}");
	
      }
    //sh_write(fd,"\\fenstermarken\n");
    sh_write(fd,"\\trennlinien\n");

    //Daten zur eigenen Person
    sh_write(fd,"\\Name {");
    if (briefkopf)      sh_write(fd,gtk_entry_get_text((GtkEntry*) header_entry_name ));
    sh_write(fd,"}\n");
    if (briefkopf)
      {
	sh_write(fd,"\\Strasse {");
	sh_write(fd,gtk_entry_get_text((GtkEntry*) header_entry_street ));
	sh_write(fd,"}\n\\Ort {");
	sh_write(fd,gtk_entry_get_text((GtkEntry*) header_entry_town));
	sh_write(fd,"}\n\\Telefon {");
	sh_write(fd,header_phone);
	sh_write(fd,"}\n\\Telefax {");	
	sh_write(fd,header_fax);
	sh_write(fd,"}\n");
      }
    else
      {
	
	sh_write(fd,"\\Strasse {}\n");
	sh_write(fd,"\\Ort {}\n");
	sh_write(fd,"\\Telefon {}\n");
	sh_write(fd,"\\Telefax {}\n");
      }
    //    sh_write(fd,"\\HTTP {}\n");
    sh_write(fd,"\\EMail {");
      sh_write(fd,gtk_entry_get_text((GtkEntry*) email_feld ));
    sh_write(fd,"}\n");

    sh_write(fd,"\\Unterschrift {");
      sh_write(fd,gtk_entry_get_text((GtkEntry*) name_feld ));
    sh_write(fd,"}\n");

    //Daten des jeweiligen Briefes
    sh_write(fd,"\\Postvermerk {}\n"); //noch nicht implementiert
    sh_write(fd,"\\Adresse {");
      sh_write(fd,adressparser(gtk_editable_get_chars((GtkEditable*) adresse_feld ,0,-1)));
    sh_write(fd,"}\n");
    sh_write(fd,"\\Betreff {");
      sh_write(fd,gtk_entry_get_text((GtkEntry*) thema_feld ));
    sh_write(fd,"}\n");
    sh_write(fd,"\\Datum {");
      sh_write(fd,gtk_entry_get_text((GtkEntry*) datum_feld ));
    sh_write(fd,"}\n");
    sh_write(fd,"\\Anrede {");
      sh_write(fd,gtk_entry_get_text((GtkEntry*) anrede_feld ));
    sh_write(fd,"}\n");
    sh_write(fd,"\\Gruss {");
      sh_write(fd,gtk_entry_get_text((GtkEntry*) gruss_feld ));
    sh_write(fd,"}{1cm}\n");
    sh_write(fd,"\\begin{document}\n");    sprintf(buffer,"latex %s/briefomat.tmp &",getenv("HOME"));
    sh_write(fd,"\\begin{g-brief}\n\n");
    /*    if (briefkopf)sh_write(fd,"\\includegraphics{/usr/share/briefomat/briefkopf.eps}\n"); */

    //Der eigentliche Text des Briefes
    sh_write(fd,gtk_editable_get_chars((GtkEditable*) text8 ,0,-1));
    sh_write(fd,"\n\n");
    sh_write(fd,"\\end{g-brief}\n");
    sh_write(fd,"\\end{document}\n");
    close(fd);
  }
}





